<?php

/**
 This project has been generated by worker generator
 has been made by fahmi sulaiman
 sulaimanfahmi@gmail.com
 check out my github @dekaulitz
 */

namespace App\Http\Services;

use App\Http\Models\PopenerimaanioModel;
use App\Http\Models\SyncUtilities\SyncHandlersModel;
use App\Http\Base\BaseService;
use Illuminate\Support\Facades\DB;

class PopenerimaanioService extends BaseService
{
	/**
     PopenerimaanioService constructor.
	 */
	public function __construct()
	{
		parent::__construct();
		$this->model = new PopenerimaanioModel();
	}

	/**
	 *  index function that get all data from database by default
	 *  @return array|static[]
	 */
	public function index()
	{
		return $this->model->getQuery()->get();
	}


	/**
	 *  this function is magic pagination injector from my library you want to add new property or field you have to inject into model in alias paging property
	 *  @param array $input
	 *  @return array
	 */
	public function paging($request)
	{
		$auth = json_decode($request->session()->get('auth'));

		$this->model->getQuery()->select([
			"popenerimaanio.id as id",
			"popenerimaanio.ioNumber as ioNumber",
			"popenerimaanio.status as status",
			"popenerimaanio.quantity as quantity",
			"popenerimaanio.date as date",
			"popenerimaanio.qtyReceiptNumber as qtyReceiptNumber"
		]);

		$arrCategory = $auth->arrCategory;
		$this->model->getQuery()->orWhereIn('popenerimaanio.ioNumber', function ($query) use ($arrCategory) {
			$query->select('itempopenerimaanio.ioNumber')->from('itempopenerimaanio')
				->join("item", "item.id", "=", "itempopenerimaanio.itemId")
				->whereIn("item.type_id", $arrCategory);
		});

		$input = $request->all();
		if (isset($input["q"])) {
			$arrKeys = explode("||", $input["q"]);
			foreach ($arrKeys as $key) {
				$arrKey = explode(":", $key);
				if (isset($arrKey[0]) && $arrKey[1] && !empty($arrKey[0])) {
					if ($arrKey[0] == "namaItem") {
						$namaItem = $arrKey[1];
						$this->model->getQuery()->where(function ($queryMain) use ($namaItem) {
							$queryMain->whereIn('popenerimaanio.ioNumber', function ($query) use ($namaItem) {
								$query->select('penerimaanbarangio.ioNumber')->from('penerimaanbarangio')
									->join("itempenerimaanbarangio", "itempenerimaanbarangio.rcNumber", "=", "penerimaanbarangio.rcNumber")
									->join("item", "item.id", "=", "itempenerimaanbarangio.itemId")
									->where("item.namaItem", "ILIKE", "%" . $namaItem . "%")
									->orWhere("item.part_number", "ILIKE", "%" . $namaItem . "%")
									->orWhere("item.deskripsi", "ILIKE", "%" . $namaItem . "%");
							});
							$queryMain->orWhereIn('popenerimaanio.ioNumber', function ($query) use ($namaItem) {
								$query->select('itempopenerimaanio.ioNumber')->from('itempopenerimaanio')
									->join("item", "item.id", "=", "itempopenerimaanio.itemId")
									->where("item.namaItem", "ILIKE", "%" . $namaItem . "%")
									->orWhere("item.part_number", "ILIKE", "%" . $namaItem . "%")
									->orWhere("item.deskripsi", "ILIKE", "%" . $namaItem . "%");
							});
						});
					} else if ($arrKey[0] == "voyageKode") {
						$voyageKode = $arrKey[1];
						$this->model->getQuery()->whereIn('popenerimaanio.ioNumber', function ($query) use ($voyageKode) {
							$query->select('penerimaanbarangio.ioNumber')->from('penerimaanbarangio')
								->where("penerimaanbarangio.voyageKode", "ILIKE", $voyageKode);
						});
					} else if ($arrKey[0] == "voyageStart") {
						$voyageStart = $arrKey[1];
						$this->model->getQuery()->whereIn('popenerimaanio.ioNumber', function ($query) use ($voyageStart) {
							$query->select('penerimaanbarangio.ioNumber')->from('penerimaanbarangio')
								// ->where("penerimaanbarangio.voyageStart", "ILIKE", $voyageStart)
								->whereRaw('"penerimaanbarangio"."voyageStart"::date =  date \'' . $voyageStart . '\'');
						});
					} else if ($arrKey[0] == "voyageEnd") {
						$voyageEnd = $arrKey[1];
						$this->model->getQuery()->whereIn('popenerimaanio.ioNumber', function ($query) use ($voyageEnd) {
							$query->select('penerimaanbarangio.ioNumber')->from('penerimaanbarangio')
								// ->where("penerimaanbarangio.voyageEnd", "ILIKE", $voyageEnd);
								->whereRaw('"penerimaanbarangio"."voyageStart"::date =  date \'' . $voyageEnd . '\'');
						});
					}
				}
			}
		}

		if ($auth->aplikasi != "HO") {
			$this->model->getQuery()->where("popenerimaanio.kapalId", "=", $auth->kapalId);
		}

		$input = $request->all();
		if (!isset($input["sort"])) {
			$this->model->getQuery()->orderBy("popenerimaanio.date", "desc");
		}

		$this->model->paging()->filter()->sorting();
		return $this->model->paging()->getPaging();
	}

	/**
	 *  get one raw row data from table by id
	 *  you can ad the relation like $this->model->joinSomething()->getQuery()->where("aliastable.field","=",$value)->first()
	 *  or like $this->model->joinSomething()->getQuery()->where("aliastable.field","=",$value)->select(["aliastable.fieldname"])->first(); its mean you want to join an take spesific value
	 *  and you want to take value like this $model->fieldname
	 *  @param $id
	 *  @return PopenerimaanioModel
	 */
	public function show($id)
	{
		$model = $this->model->getQuery()->where("popenerimaanio.id", "=", $id)->first();
		return $model;
	}

	public function showBasedOnIONumber($request, $pbIO)
	{
		$model = $this->model->getQuery()
			->where("popenerimaanio.ioNumber", "=", $pbIO->ioNumber)
			->where("popenerimaanio.kapalId", "=", $pbIO->kapalId)
			->first();
		return $model;
	}


	/**
	 *  this is a base function for storing data you with transaction by default
	 *  you can customization base on your business requirement as you want, you can add other object or you can to loop anc excecute the process in single process
	 *  @param array $input
	 *  @return PopenerimaanioModel
	 *  @throws \Exception
	 */
	public function store($input)
	{
		$this->model->fill($input);
		if (!$this->model->save()) {
			throw new \Exception();
		}
		return $this->model;
	}


	/**
	 * this function will delete much data, in one action
	 * the ids is a parameter from view like 1,2,3,4 and the parameter will be exploded into single array
	 * you can remove this main alogorithm with your business requirement like soft delete or anything you want
	 *  @param $ids
	 */
	public function delete($ids)
	{
		$params = explode(".", $ids);
		$this->model->deleteBulk("id", $params);
	}


	/**
	 *  this is a base function for update and delete data by default.
	 *  you can add and custom as you want base on your requirement you can add this function as core function for handle update data from table or 
	 *  you can add multiple relation proses after update in this function 
	 *  @param $id
	 *  @param array $input 
	 *  @return PopenerimaanioModel
	 *  @throws \Exception
	 */
	public function update($id, $input)
	{
		$popenerimaanio = PopenerimaanioModel::find($id);
		$popenerimaanio->fill($input);
		if (!$popenerimaanio->update()) {
			throw new \Exception();
		}
		return $popenerimaanio;
	}


	/**
	 *  this function will be confirting paging property into file excel
	 *  the main library is base on excel spreadsheet library
	 *  @param array $input
	 *   @return array|static[]
	 */
	public function exportToExcel($input = array())
	{
		return $this->model->getQuery()->get();
	}

	/* public function updateStatusPO($ioNumber) {
		$data = ["status" => 1, "ioNumber" => $ioNumber];
		$popenerimaan = PopenerimaanioModel::where("ioNumber", $ioNumber);
		if(!$popenerimaan->update($data)){
			throw new \Exception();
		}
		return $popenerimaan;
	} */

	public function updateStatusPO($status, $input)
	{
		$popenerimaan = PopenerimaanioModel::where("ioNumber", $input["ioNumber"])->first();
		if ($popenerimaan) {
			$poID = $popenerimaan->id;
			$qtyDiterima = $popenerimaan->qtyReceiptNumber;
			if (isset($input["itemID"])) {
				$qtyDiterima += array_sum($input["quantity"]);
			}
			$data = [
				"status" => $status,
				"ioNumber" => $input["ioNumber"],
				"qtyReceiptNumber" => $qtyDiterima
			];
			$popenerimaan = PopenerimaanioModel::where("ioNumber", $input["ioNumber"]);
			if (!$popenerimaan->update($data)) {
				throw new \Exception();
			}

			$sync = SyncHandlersModel::where("sync.local_id", "=", $poID)->where("sync.table_name", "=", "popenerimaanio");
			if (!$sync->update(["need_sync" => 1])) {
				throw new \Exception();
			}
			return $popenerimaan;
		}
	}
}
